//K yAj[V̊Jnƒ~
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.imageio.*;  
import java.applet.*;
import java.net.*;

public class RabbitDanceM extends JPanel implements ActionListener {
   JButton b1, b2;
   RabbitAnimation area;

   public RabbitDanceM(){  
      JPanel p1 = new JPanel(); //{^upl
      b1 = new JButton("X^[g");
      b2 = new JButton("Xgbv");
      b1.addActionListener(this);
      b2.addActionListener(this);
      p1.add(b1);
      p1.add(b2);
 
      area = new RabbitAnimation();
      setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
      add(area);//㕔RabbitAnimationplzu
      add(p1);//Ƀ{^uplzu
   }

   public void actionPerformed(ActionEvent e) { //ANVCxg
      Object obj = e.getSource();
      if(obj == b1){          //b1ꂽ
	 area.startDance();
      }
      else if(obj == b2){     //b2ꂽ
         area.stopDance();
      }
   }
   public static void main(String[] args) {
      JFrame frame  = new JFrame("Animation");
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      RabbitDanceM k = new RabbitDanceM();
      frame.add(k, BorderLayout.CENTER);
      frame.pack();
      frame.setVisible(true);
   }
}


class RabbitAnimation extends JPanel implements ActionListener {
   int number = -1;       //\摜̔ԍ
   int cell = 20;         //摜̐
   int interval =300;     //摜̕\Ԋu(Pʃ~b)
   Timer timer;           //^C}[pϐ
   Image[] image;         //摜i[z
   Image stage;           //wi摜pϐ
   AudioClip clip;
   URL url;

   RabbitAnimation() {
      try{ stage = ImageIO.read(new File("rabbit/stage.gif")); //摜̃[h
      }catch(IOException e){System.out.println("t@C[hł܂");}

      image = new Image[cell];
      for (int i = 1; i <= cell; i++) {   //摜̃[h
         try{ 
            image[i-1] = ImageIO.read(new File("rabbit/rabbit" + i + ".gif"));
         }catch(IOException e){System.out.println("t@C[hł܂");}
      }
      try { //̃[h
         url = new URL("file:" + System.getProperty("user.dir") + "/usagid.mid");
      }catch(MalformedURLException e) {System.out.println("t@C܂");}
      clip = Applet.newAudioClip(url);

      timer = new Timer(interval, this); //^C}[̐
      timer.setInitialDelay(0);          //Ɏn߂
      timer.setCoalesce(true);           //Cxg܂Ƃ߂
      setPreferredSize(new Dimension(stage.getWidth(this), stage.getHeight(this)));
    }

    void startDance(){
       if(!timer.isRunning()) {
          timer.start();
          clip.loop();
       }
    }
    void stopDance(){
       if(timer.isRunning()) {
          timer.stop();
          clip.stop();
       }
    }

    public void actionPerformed(ActionEvent e) { //ANVCxg
       number++;  
       number = number%cell;  //ɕ\摜̔ԍ
       repaint(); //`
    }

    public void paintComponent(Graphics g) {
       super.paintComponent(g); //wi̕`
       g.drawImage(stage, 0, 0, this);
       int x = getWidth()/2-30; //EBhÊقڒɂ\
       int y = getHeight()/2+20;
       try { //number0-19ȊO̎ɕ`悪Ă΂ꂽ̗O
          g.drawImage(image[number], x, y, this);
       } catch (ArrayIndexOutOfBoundsException e) { 
            g.drawImage(image[0], x, y, this); }
    }
}






